﻿--0. indítsuk el a QGIS telepítőt (2.18, 64 bit)

--1. forrásadatok
select COUNT(*) from euab.dbo.taj_esem where esemsor is not null

--2. importáljuk a csv fájlt -> koord tábla

--segítség: a geog átalakítás:
select irszam, telepules_id, tnev, lelekszam, hosszusag, szelesseg, 
Geography::Point(cast(SUBSTRING(szelesseg,1,2) as float) + cast(SUBSTRING(szelesseg,4,4) as float)/60.0,
	cast(SUBSTRING(hosszusag,1,2) as float) + cast(SUBSTRING(hosszusag,4,4) as float)/60.0, 4326) as g
from koord

--3. az új koord táblának legyen egy identity int típusú és gid nevű mező a kulcsa, 
--és egy g nevű mezőben a fenti geog típusú adat

--4. a euab.dbo.taj_esem tábláról készítsünk saját másolatot

--5. adjuk hozzá az inv_tipus int mezőt, és állítsuk be ennek értékét

--6. egy új táblába válasszuk ki a koord táblából településenként az invazív arányt,
--ami az invazívan kezdődő esetek aránya az összes esethez képest az adaott település lakói körében
--lehet, hogy egy ideiglenes táblával egyszerűbb

--6a. (ha van idő rá) az esemsor átalakítása: 'PPSSSST' -> 'PST'
--segítség:
select REPLACE('PPSSSST', 'PP', 'P') --PSSSST
select REPLACE('PSSSST', 'SS', 'S') --PSST

--6b. adjuk hozzá az új táblához új mezőkben az egyes típusok arányát az összes esethez képest településenként

--VIGYÁZAT! Geography típusú mező alapján nem lehet csoportosítani

--7. az új táblát nyissuk meg a QGIS-ben, és készítsünk belőle egy térképet
--külön rétegeken az invazív arány és a többi arány
/*
Segítség: 
Beállítások QGIS 2.18-hoz:

Megnyitás után Project properties -> enable on the fly CRS trans, HD72/EOV-ra átállítani
style: graduated
method: color
column: lelekszam
symbol -> size, edit: 2 + to_int(lelekszam)/20000
mode: quantile
labels: tnev

*/


--HÁTTÉRANYAG: GEOGRAPHY ADATTÍPUS

--hasonlóképpen a geography adattípusra:
IF OBJECT_ID ( 'dbo.SpatialTable', 'U' ) IS NOT NULL 
    DROP TABLE dbo.SpatialTable2;
GO

CREATE TABLE SpatialTable2
    ( id int IDENTITY (1,1),
    GeogCol1 geography, 
    GeogCol2 AS GeogCol1.STAsText() );
GO

INSERT INTO SpatialTable2 (GeogCol1)
VALUES (geography::STGeomFromText('LINESTRING(-122.360 47.656, -122.343 47.656)', 4326));

INSERT INTO SpatialTable2 (GeogCol1)
VALUES (geography::STGeomFromText('POLYGON((-122.358 47.653, -122.348 47.649, -122.348 47.658, -122.358 47.658, -122.358 47.653))', 4326));
GO
 
select * from SpatialTable2
--The second example uses the STIntersection() method to return the points where the two previously inserted geography instances intersect.
-- STIntersection

DECLARE @geog1 geography;
DECLARE @geog2 geography;
DECLARE @result geography;

SELECT @geog1 = GeogCol1 FROM SpatialTable2 WHERE id = 1;
SELECT @geog2 = GeogCol1 FROM SpatialTable2 WHERE id = 2;
SELECT @result = @geog1.STIntersection(@geog2);
select @result
SELECT @result.STAsText();
 
 --még egy geogr. példa:
DECLARE @g geography;
DECLARE @h geography;
SET @g = geography::STGeomFromText('LINESTRING(-122.360 47.656, -122.343 47.656)', 4326);
SET @h = geography::STGeomFromText('POINT(-122.34900 47.65100)', 4326);
SELECT @g.STDistance(@h);
 
 
/****************************************** 
 --az összes geography metódus:
 ******************************************
 
STArea (geography Data Type) 
STAsBinary (geography Data Type) 
STAsText (geography Data Type) 
STBuffer (geography Data Type) */
DECLARE @g geography;
SET @g = geography::STGeomFromText('LINESTRING(-122.360 47.656, -122.343 47.6956)', 4326);
SELECT @g.STBuffer(100), @g.STBuffer(100).ToString();
--STDimension (geography Data Type) 
DECLARE @temp table ([name] varchar(10), [geom] geography);
INSERT INTO @temp values ('Point', geography::STGeomFromText('POINT(-122.34900 47.65100)', 4326));
INSERT INTO @temp values ('LineString', geography::STGeomFromText('LINESTRING(-122.360 47.656, -122.343 47.656)', 4326));
INSERT INTO @temp values ('Polygon', geography::STGeomFromText('POLYGON((-122.358 47.653, -122.348 47.649, -122.348 47.658, -122.358 47.658, -122.358 47.653))', 4326));
SELECT [name], [geom].STDimension() as [dim] FROM @temp;
/*
STDisjoint (geography Data Type) 
STDistance (geography Data Type) 
STEndpoint (geography Data Type) 
STGeometryN (geography Data Type)	
*/
DECLARE @g geography;
SET @g = geography::STGeomFromText('MULTIPOINT(-122.360 47.656, -122.343 47.656)', 4326);
SELECT @g.STGeometryN(2).ToString(), @g.STNumGeometries();

--STGeometryType (geography Data Type)
--Point, LineString, Polygon, GeometryCollection, MultiPoint, MultiLineString, and MultiPolygon. 
STIntersection (geography Data Type) 
STIntersects (geography Data Type) 
STIsClosed (geography Data Type) 
STIsEmpty (geography Data Type) 
STLength (geography Data Type) 
STNumGeometries (geography Data Type) 
STNumPoints (geography Data Type) --hány pontból áll a görbe
STPointN (geography Data Type) --az n-edik pont
STSrid (geography Data Type) --4326
STStartPoint (geography Data Type) 
STUnion (geography Data Type) 
*/
DECLARE @g geography;
DECLARE @h geography;
SET @g = geography::STGeomFromText('POLYGON((-122.358 47.653, -122.348 47.649, -122.348 47.658, -122.358 47.658, -122.358 47.653))', 4326);
SET @h = geography::STGeomFromText('POLYGON((-122.351 47.656, -122.341 47.656, -122.341 47.661, -122.351 47.661, -122.351 47.656))', 4326);
select @g 
select @h
SELECT @g.STUnion(@h), @g.STUnion(@h).ToString();

/*
--PÉLDA: Melyek azok a fővárosok, melyek 1000 km sugarú környezetében nincs hegy?

1) keressük meg azokat a városokat, melyeknek 1000 km 
sugarú környezetében VAN hegy
2) ez alapján (al-lekérdezéssel) keressük meg azokat a városokat, melyeknek 1000 km 
sugarú környezetében NINCS hegy
3) és rajzoljuk ki ezen városok körüli 
1000km sugarú buffer területeket
4) a foltokba írjuk bele a város nevét! (select label column: nev
5) szűkítsük a találatokat a fővárosokra (a country táblából)!

--hetven ilyen főváros van
********************************************/
use mondial
select Name as nev, geog.STBuffer(1000000) as buffer 
			--ha nincs alias neve a Name mezőnek, nem teszi ki a címkét
from city where Name not in (
	select city.Name as varosnev
	from city, mountain
	where city.geog.STDistance(mountain.geog) < 1000000
) and geog is not null
and Name in (select capital from country)





--további érdekességek: http://www.beginningspatial.com/beginning_spatial
--komolyabb GIS rendszer: http://qgis.org/
